<template>
    <!-- <v-content> -->
    <v-container fluid class="profile-container" min-height="700">
        <v-row justify="center">
            <v-col cols="12" sm="12" md="3" class="menu-container" height="100%">
                <v-card class="mx-auto elevation-3" tile height="100%">
                    <v-card-title>
                        <v-list-item-avatar size="40" color="white" rounded=true>
                            <v-img v-if="hasProfilePicture" :src="imageUrl" alt="Profile picture">
                            </v-img>
                            <v-icon v-else large left>
                                mdi-account-circle
                            </v-icon>
                        </v-list-item-avatar>
                        <span class="font-weight-light custom-fullname">{{fullName}}</span>
                    </v-card-title>
                    <v-list>
                        <v-list-item-group :value="item" color="primary">
                            <v-list-item v-for="(item, i) in items" :key="i">
                                <router-link :to="{ name: item.route }" class="custom-link">
                                    <v-list-item-icon>
                                        <v-icon v-text="item.icon"></v-icon>
                                    </v-list-item-icon>
                                    <v-list-item-content>
                                        <v-list-item-title v-text="item.text"></v-list-item-title>
                                    </v-list-item-content>
                                </router-link>
                            </v-list-item>
                        </v-list-item-group>
                    </v-list>
                </v-card>
            </v-col>
            <v-col class="infos-container" cols="12" sm="12" md="9">
                <router-view></router-view>
            </v-col>
        </v-row>
    </v-container>
    <!-- </v-content> -->
</template>

<script>
import { ENTRYPOINT } from '../../config/entrypoint';
import { mapFields } from 'vuex-map-fields';
import NotificationMixin from '../../mixins/NotificationMixin';

export default {
  name: 'ProfileView',
  mixins: [NotificationMixin],
  components: {
    // UserInfos
  },
  data : () => ({
    item:0,
    items: [
      { text: 'Profile', route:'profileUser', icon: 'mdi-account' },
      { text: 'Adresse', route:'profileAdress', icon: 'mdi-map-marker' },
      { text: 'Commandes', route:'profileOrders', icon: 'mdi-history' },
    ],
    hasProfilePicture:false,
    imageUrl: '',
  }),
  computed: {
    fullName() {
        if (this.userInfos) {
            return this.userInfos.lastName.toUpperCase() + ' ' + this.userInfos.firstName;
        } else {
            return null;
        }
    },
    ...mapFields('user', ['userInfos', 'loggedIn', 'tempProfilePicture']),
  },
  created() {
    for (let i = 0; i < this.items.length; i++) {
        const routing = this.items[i];
        if (routing.route === this.$route.name) {
            this.item = i;
            return;
        }
    }
  },
  watch: {
    userInfos(newUserInfos) {
        if (newUserInfos && newUserInfos.id && newUserInfos.avatar) {
          this.hasProfilePicture = true;
          if (!this.imageUrl && newUserInfos.avatar) {
            this.imageUrl = ENTRYPOINT + '/media/' +  newUserInfos.avatar.filePath;
          }
        }
    },
    tempProfilePicture(newPicture) {
      if (newPicture) {
        this.imageUrl = ENTRYPOINT + newPicture.imageUrl;
      }
    }
  },
};
</script>

<style lang="scss" scoped>
.profile-container {
  min-height: 600px;
  .infos-container {
    min-height: 600px;
  }
}
.custom-link {
  width: 100%;
  display: flex;
  text-decoration: none;
}
.custom-fullname {
  width: 55%;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
.title {
	overflow: hidden;
	width: 100%;
	white-space: nowrap;
}
</style>
